"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.transformLessToCssVariable = void 0;
const postcss_1 = __importDefault(require("postcss"));
const syntax = __importStar(require("postcss-less"));
const fs_extra_1 = require("fs-extra");
const transformPlugin = ({ resolveRoot, atRules, decls, }) => {
    return {
        postcssPlugin: 'transformLessToCssVariablePlugin',
        Root(root) {
            resolveRoot?.(root);
        },
        async AtRule(atRule, helper) {
            if (atRules) {
                Promise.all(atRules.map((fn) => fn(atRule, helper)));
            }
        },
        Declaration(decl, helper) {
            if (decls) {
                Promise.all(decls.map((fn) => fn(decl, helper)));
            }
        },
    };
};
const transformLessToCssVariable = async (filePath, options) => {
    if (!(0, fs_extra_1.existsSync)(filePath)) {
        throw new Error(`[transformLessToCssVariable] ${filePath} file does not exist.`);
    }
    const fileContent = (await (0, fs_extra_1.readFile)(filePath)).toString('utf-8');
    return (0, postcss_1.default)([transformPlugin(options)])
        .process(fileContent, { syntax, from: filePath })
        .then((result) => options.formatResult?.(result) ?? result)
        .catch((e) => console.log('postcss error', e));
};
exports.transformLessToCssVariable = transformLessToCssVariable;
