"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const upperFirst_1 = __importDefault(require("lodash/upperFirst"));
const util_1 = require("../../client/util");
function createBaseTemplate(funcName) {
    const upName = (0, upperFirst_1.default)(funcName);
    return `.cover${upName}Mixin() {
  @functions: ~\`(function() {
    this.cover${upName} = function(color, amount) {
      if (String(color).indexOf('var(') === 0) {
        /*
          (var(--primary-color), 7) -> var(--primary-7)
        */
        if (color.indexOf('--primary-color') !== -1 ) {
          var m = amount > 10 ? amount/10 :amount
          return color.replace('-color)',  '-' + m + ')')
        }
        /*
          (var(--error-color), 70%) ===> var(--error-color--${funcName}-7)
        */
        return color.replace(')',  '--${funcName}--' + parseInt(amount) + ')')
      }
      return color
    }
  })()\`;
}
.cover${upName}Mixin();\n`;
}
const result = {};
util_1.COLOR_FUNC_NAME_LIST.forEach((funcName) => {
    const name = `cover${(0, upperFirst_1.default)(funcName)}Template`;
    if (funcName === 'color') {
        result[name] = ``;
    }
    else {
        result[name] = createBaseTemplate(funcName);
    }
});
exports.default = result;
