"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.compose = exports.defineRuleOptions = exports.getBackupFilePath = void 0;
const path_1 = __importDefault(require("path"));
const constants_1 = require("../constants");
const isFunction_1 = __importDefault(require("lodash/isFunction"));
// Get the location of the backup file
const getBackupFilePath = (mainPath, backupPath) => {
    if (backupPath) {
        return backupPath;
    }
    const ext = path_1.default.extname(mainPath);
    if (mainPath.endsWith(`${constants_1.BACKUP_EXT}${ext}`)) {
        return mainPath;
    }
    return mainPath.replace(ext, constants_1.BACKUP_EXT + ext);
};
exports.getBackupFilePath = getBackupFilePath;
const defineRuleOptions = (options) => options;
exports.defineRuleOptions = defineRuleOptions;
const compose = (...args) => (params) => args.reduce((prev, current) => {
    const result = (0, isFunction_1.default)(prev) ? prev(params) : prev;
    return current(result);
});
exports.compose = compose;
